/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#ifndef __ERIKYYYLIST_H
#define __ERIKYYYLIST_H



// **** liste ***************************************************************

template <class X>
class liste;

template <class X>
class liste_elem {
friend class liste<X>;
public:
  liste_elem *next,*prev;
  X *objptr;
};


template <class X>
class liste {
public:
  liste_elem<X>* first;

  liste() {
    first=0;
  };

  ~liste() {
    killall();
  };

  void addfront(X *neu) {
    liste_elem<X> *a=new liste_elem<X>();
    if (first) first->prev=a;
    a->next=first;
    a->prev=0;
    a->objptr=neu;
    first=a;
  };

  void del(liste_elem<X> *w) {
    if (w->prev) {
      w->prev->next=w->next;
    }else{
      first=w->next;
    };
    if (w->next) w->next->prev=w->prev;
    if (w->objptr) delete w->objptr;
    delete w;
  };

  void del_and_next(liste_elem<X> **w) {
    liste_elem<X> *i=*w;
    (*w)=i->next;
    del(i);
  };

  void killall() {
    while (first) del(first);
  };
};

#endif
