/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#ifndef __SERVERCONNECTION_H
#define __SERVERCONNECTION_H

#include "MSG.H"
#include "erikyyylist.H"

typedef struct {
  enum {ON_AIR=0,IDLE=1,BUFFER=2,WANT_TO_PLAY=3}; // achtung werte gleich wie bei outconnection.H !!!
  int32 ip;
  char status; // nur ein char ! wegen byte order problem. (dies hier ist eigentlich ein statustype)
  // spaeter achtung big/little endian problem bei typconvertierung ueber pointer...
  int16 buffill;
  int8 latency;
  int32 ____pad;   // spaeter wegmachen. ist nur wegen fatalfehlercheck ueberpruefen :)
} serverconnection_statustype;

class serverconnection {
public:
  serverconnection(MSG_communicator *com_,int32 _ip);
  ~serverconnection();

  void notifynewclient(MSG_communicator *x);
  int handleevent();

  serverconnection_statustype st;
  void setrellatency(int rellatency);

private:
  int playgsms,sleepgsms,spielaktiv;
  MSG_communicator *com;
  int erzeugeplaygsms;
  int sound_aktiv;
  buffer *buf,*rawbuf;
};

extern liste<serverconnection> *serverconnectionlist;

#endif
